import { IApiError, ConfigValidator } from "matrix-appservice-bridge";
import { Response } from "express";
export interface LinkValidatorProperties {
    matrix_room_id: string;
    remote_room_channel: string;
    remote_room_server: string;
    op_nick: string;
    key?: string;
}
export declare const LinkValidator: ConfigValidator;
export interface QueryLinkValidatorProperties {
    remote_room_channel: string;
    remote_room_server: string;
    key?: string;
}
export declare const QueryLinkValidator: ConfigValidator;
export interface UnlinkValidatorProperties {
    remote_room_channel: string;
    remote_room_server: string;
    matrix_room_id: string;
}
export declare const UnlinkValidator: ConfigValidator;
export interface ListingsProperties {
    matrix_room_id: string;
}
export declare const RoomIdValidator: ConfigValidator;
export declare enum IrcErrCode {
    UnknownNetwork = "IRC_UNKNOWN_NETWORK",
    UnknownChannel = "IRC_UNKNOWN_CHANNEL",
    UnknownRoom = "IRC_UNKNOWN_ROOM",
    DoubleBridge = "IRC_DOUBLE_BRIDGE",
    ExistingMapping = "IRC_EXISTING_MAPPING",
    ExistingRequest = "IRC_EXISTING_REQUEST",
    NotEnoughPower = "IRC_NOT_ENOUGH_POWER",
    BadOpTarget = "IRC_BAD_OPERATOR_TARGET",
    BridgeAtLimit = "IRC_BRIDGE_AT_LIMIT"
}
export declare class IrcProvisioningError extends Error implements IApiError {
    readonly error: string;
    readonly errcode: IrcErrCode;
    readonly statusCode: number;
    readonly additionalContent: Record<string, unknown>;
    constructor(error: string, errcode: IrcErrCode, statusCode?: number, additionalContent?: Record<string, unknown>);
    get jsonBody(): {
        errcode: string;
        error: string;
    };
    apply(response: Response): void;
}
